﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=13.1
@EndOfDesignText@
'#DesignerProperty: Key: BooleanExample, DisplayName: Show Seconds, FieldType: Boolean, DefaultValue: True
'#DesignerProperty: Key: TextColor, DisplayName: Text Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Text color

#DesignerProperty: Key: QRCodePromtPay ,DisplayName: Create QRCode PromptPay ,FieldType: ImageView ,DefaultValue : Bitmap
#DesignerProperty: Key: CashMoney ,DisplayName: Cash Money,FieldType: String, DefaultValue: "0.00" ,Description: Number of money
#DesignerProperty: Key: PromptPayAccount,DisplayName:Account of Prompt Pay ,FieldType: String, DefaultValue: "" ,Description: PromptPayAccount which you have
#DesignerProperty: Key: ReferAccNo,DisplayName:Refer to Account Number ,FieldType: String, DefaultValue: "" ,Description: Refer to Account Number which you have
#DesignerProperty: Key: hasLogo, DisplayName: Show Logo,or not, FieldType: Boolean, DefaultValue: No
#DesignerProperty: Key: Logo, DisplayName: Logo Icon, FieldType: Bitmap, Description: Add Logo bitmap


Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
    mBase.Tag = Me 
	'Dim clr As Int = xui.PaintOrColorToColor(Props.Get("TextColor")) 'Example of getting a color value from Props
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub


Sub QRCodePromtPay(cashmoney As String,myPromptPayAccount As String,myReferAccNo As String,hasLogo As Boolean,myLogo As Bitmap)As ImageView
	Private	mPromptPayAccount As String=myPromptPayAccount
	Private mReferAccNo As String=myReferAccNo
	Private aqrc As  AwesomeQRCode_1
	Private bm  As Bitmap =myLogo
	Private bm1 As Bitmap   'ไม่ใส่ logo  ต้องการรูป Backgroud เท่านั้น
	Private ImageView1 As ImageView
	
	aqrc.Initialize("")
	aqrc.autoColor(True)
	cashmoney = cashmoney.Replace("บาท", "").Trim
	cashmoney = cashmoney.Replace(",", "").Trim
	
	'Dim cashvalue As Double = cashmoney
	Dim cashvalue As Int = cashmoney

	cashmoney = NumberFormat2(cashvalue, 1, 2, 2, False)
	Dim content1 As String = "00020101021129390016" & mPromptPayAccount & "0315" & mReferAccNo
	Dim tmp As Int = cashmoney.Length
	Dim content2 As String = "54" & IIf(tmp > 9, tmp, "0" & tmp)
	
	Dim content3 As String
	Dim msg As String
	If cashvalue = 0 Then
		content3 = "5303764" & "5802TH"
		msg = content1 & content3 & "6304"
	Else
		content3 = "5802TH" & "5303764"
		msg = content1 & content2 & cashmoney & content3 & "6304"
	End If
	
	
	Dim aBuf() As Byte
	
	
	Dim ByteConv As ByteConverter
	'aBuf=ByteConv.StringToBytes(m,"UTF8") ' หรือเขียนอีกแบบหนึ่งตามคำสั่งข้างล่าง
	aBuf=msg.GetBytes("UTF8")
	
	Dim myCRC As Int=CRC16A(aBuf)
	
	Dim intArr() As Int = Array As Int(myCRC)
	Dim HexCRC As String =ByteConv.HexFromBytes(ByteConv.IntsToBytes(intArr))
	HexCRC = IIf(HexCRC.StartsWith("0000"), HexCRC.SubString(4), HexCRC)
	'Log(HexCRC)
	
	


	

	aqrc.contents(msg&HexCRC)
	
	
	
	aqrc.background(bm)
	
	'ถ้าหากสร้าง QRCode แล้วไม่สามารถถอดรหัสได้   ต้องลองเปลี่ยน  aqrc.dotScale(0.8)
	aqrc.dotScale(0.8)
	

	aqrc.logoScale(0.35)
	aqrc.logoMargin(20)
	aqrc.logoRadius(10)
	aqrc.logo(bm1)  'ไม่ใส่ logo  ต้องการรูป Backgroud เท่านั้น
	
	aqrc.binarizeThreshold(128)
	aqrc.binarize(False)
	
	aqrc.colorDark(Colors.Black)
	aqrc.colorLight(Colors.White)
	
	aqrc.margin(30)
	
	
	aqrc.roundedDots(True)
	
	aqrc.whiteMargin(True)

	ImageView1.Bitmap = aqrc.render
	
	Return  ImageView1
	
End Sub


Private Sub CRC16A(Buffer() As Byte) As Int
	Dim Temp As Int
	Dim crc1 As Int
	
	crc1 = 0xFFFF
	
	For i = 0 To Buffer.Length - 1
		Temp = Bit.And(Buffer(i), 0xFF) * 0x0100
		crc1 = Bit.Xor(crc1, Temp)
		For j = 0 To 7
			If Bit.And(crc1, 0x8000) <> 0 Then
				crc1 = Bit.And(Bit.Xor(crc1 * 2, 0x1021), 0xFFFF)
			Else
				crc1 = Bit.And(crc1 * 2, 0xFFFF)
			End If
		Next
	Next
	Return crc1
End Sub
